module type THEORIE =
  sig
    type seq
    type rule_un
    type rule_bin
    val seq_equal : seq -> seq -> bool
    val is_axiom : seq -> bool
    val func_un : rule_un -> seq -> seq
    val func_bin : rule_bin -> seq -> seq -> seq
    val match_un : seq -> seq -> rule_un
    val match_bin : seq -> seq -> seq -> rule_bin
    val string_of_seq : seq -> string
    val string_of_rule_un : rule_un -> string
    val string_of_rule_bin : rule_bin -> string
  end
module type S =
  sig
    type seq
    type optree
    type seqtree
    type prooftree
    val fromOp : optree -> prooftree
    val fromSeq : seqtree -> prooftree
    val toOp : prooftree -> optree
    val toSeq : prooftree -> seqtree
    val result : prooftree -> seq
    val verify : prooftree -> bool
    val aff : prooftree -> ColFormat.column
    val printer : Format.formatter -> prooftree -> unit
  end
module Make :
  functor (T : THEORIE) -> 
  (S with type seq       = T.seq
      and type optree    = (T.seq, T.rule_un, T.rule_bin) OneTwoTree.tree
      and type seqtree   = (T.seq, T.seq, T.seq) OneTwoTree.tree
      and type prooftree = (T.seq, T.rule_un, T.rule_bin) OneTwoTree.prooftree)
